//*****************************************************************************
//*****************************************************************************
//  FILENAME: CNA.h
//   Version: 2.2, Updated on 2011/6/28 at 6:9:3
//  Generated by PSoC Designer 5.1.2306
//
//  DESCRIPTION:  DAC8 User Module C language interface file.
//-----------------------------------------------------------------------------
//      Copyright (c) Cypress Semiconductor 2011. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************
#ifndef CNA_INCLUDE
#define CNA_INCLUDE

#include <m8c.h>

//-------------------------------------------------
// Defines for CNA API's.
//-------------------------------------------------
// Power Setting Defines
#define CNA_OFF                 0
#define CNA_LOWPOWER            1
#define CNA_MEDPOWER            2
#define CNA_HIGHPOWER           3
#define CNA_FULLPOWER           3

// Define constants for declaring function prototypes based on DataFormat parameter
#define CNA_OffsetBinary            0x04
#define CNA_TwosComplement          0x02
#define CNA_SignAndMagnitude        0x01
#define CNA_RawRegister             0x00
#define CNA_DATAFORMAT          0x7
#define CNA_OFFSETBINARY        CNA_DATAFORMAT & CNA_OffsetBinary
#define CNA_TWOSCOMPLEMENT      CNA_DATAFORMAT & CNA_TwosComplement
#define CNA_SIGNANDMAGNITUDE    CNA_DATAFORMAT & CNA_SignAndMagnitude

// Declare function fastcall16 pragmas
#pragma fastcall16 CNA_Start
#pragma fastcall16 CNA_SetPower
#pragma fastcall16 CNA_Stop

//-------------------------------------------------
// Prototypes of the CNA API.
//-------------------------------------------------
extern void  CNA_Start(BYTE bPowerSetting);
extern void  CNA_SetPower(BYTE bPowerSetting);
extern void  CNA_Stop(void);

// Declare overloaded functions based on DataForamt parameter selected
#if CNA_OFFSETBINARY
   #pragma fastcall16 CNA_WriteBlind
   #pragma fastcall16 CNA_WriteStall
   extern void  CNA_WriteBlind(BYTE bOutputValue);
   extern void  CNA_WriteStall(BYTE bOutputValue);
#else
   #if CNA_TWOSCOMPLEMENT
      #pragma fastcall16 CNA_WriteBlind
      #pragma fastcall16 CNA_WriteStall
      extern void  CNA_WriteBlind(CHAR cOutputValue);
      extern void  CNA_WriteStall(CHAR cOutputValue);
   #else    //CNA_SIGNANDMAGNITUDE
      #pragma fastcall16 CNA_WriteBlind2B
      #pragma fastcall16 CNA_WriteStall2B
      extern void  CNA_WriteBlind2B(BYTE bLSB, BYTE bMSB);
      extern void  CNA_WriteStall2B(BYTE bLSB, BYTE bMSB);
   #endif
#endif

//-------------------------------------------------
// Hardware Register Definitions
//-------------------------------------------------

#pragma ioport  CNA_LSB_CR0:    0x084                      // LSB Analog control register 0
BYTE            CNA_LSB_CR0;
#pragma ioport  CNA_LSB_CR1:    0x085                      // LSB Analog control register 1
BYTE            CNA_LSB_CR1;
#pragma ioport  CNA_LSB_CR2:    0x086                      // LSB Analog control register 2
BYTE            CNA_LSB_CR2;
#pragma ioport  CNA_LSB_CR3:    0x087                      // LSB Analog control register 3
BYTE            CNA_LSB_CR3;

#pragma ioport  CNA_MSB_CR0:    0x094                      // MSB Analog control register 0
BYTE            CNA_MSB_CR0;
#pragma ioport  CNA_MSB_CR1:    0x095                      // MSB Analog control register 1
BYTE            CNA_MSB_CR1;
#pragma ioport  CNA_MSB_CR2:    0x096                      // MSB Analog control register 2
BYTE            CNA_MSB_CR2;
#pragma ioport  CNA_MSB_CR3:    0x097                      // MSB Analog control register 3
BYTE            CNA_MSB_CR3;

#endif
// end of file CNA.h
