//----------------------------------------------------------------------------
// C main line
//----------------------------------------------------------------------------

#include <m8c.h>        // part specific constants and macros
#include "PSoCAPI.h"    // PSoC API definitions for all User Modules


void main(void)
{
    // Insert your main routine code here.
	BYTE value =0;
	float x=0;
	unsigned int mV_hex = 0 ;
	unsigned char mV_dec[5] ;
	char *ptr_mV_dec ;
	char raz[5]="00000" ;
	
	// Initialisation des blocs hardware et autorisation des interruptions
	PGA_Start(PGA_HIGHPOWER); 
	LCD_Start();
	CAN_Start(CAN_HIGHPOWER);
	CAN_StartAD();
	CNA_Start(CNA_HIGHPOWER);
	M8C_EnableGInt;
	
	// Place LCD cursor 
    LCD_Position(0,1);
    LCD_PrCString("Conversion");
    LCD_Position(1,1);
	LCD_PrCString("Vamp = ");
	
	while(1)
    {
        // Attente de la fin d'une conversion et de la disponibilité du résultat	  
        while(CAN_fIsDataAvailable() == 0);   
        
        // Lecture de la sortie du CAN et RAZ du flag
		value=CAN_cGetDataClearFlag();
		
		// Conversion de la valeur signée fournie par le convertisseur
		// en une valeur en binaire décalée
		value = value + 0x80 ;
		
		
		// Ecriture de la grandeur numérique obtenue dans le CNA
		CNA_WriteBlind(value);
		
		// Conversion de la valeur lue en une valeur de tension en mV
		x = value ;
		x = (4800*x)/256 ;
		mV_hex = x ;
		
		// Conversion de la valeur de la tension en une chaîne de caratères
		// représentant la valeur de la tension en décimal
		ptr_mV_dec = mV_dec ;
		itoa(ptr_mV_dec,(int)mV_hex,10) ;
	    		
        // affichage sur le LCD du résultat de la conversion  
		LCD_Position(1,11);
        LCD_PrHexByte(value);
		
		// affichage sur le LCD de la valeur de la tension en décimal
		//if (mV_hex < 1000)  
		//{LCD_PrCString("0");}
		//if (mV_hex < 100)  
		//{LCD_PrCString("0");}
		//if (mV_hex < 10)  
		//{LCD_PrCString("0");}
		//LCD_PrString(ptr_mV_dec);
		
		// Ecriture du résultat de la conversion (sur 8 bits) sur le port 1
		PRT1DR=value;

    }	
}
